/**********************************************************
* Semestralni prace I. - "KAREL"
* Predmet AD7B36PSI
**********************************************************/
/**********************************************************
* 3. semestr, zima 2010/2011
**********************************************************/
/**********************************************************
* Zpracovala: Radoslava Jandova
* Uzivatelske jmeno: jandora1
* Konzultace: Michal Rathouzsky
**********************************************************/
/**********************************************************
* Zdroje:	stranky predmetu Pocitacove komunikace
			http://www.stm-wiki.cz
			http://msdn.microsoft.com
			http://www.wikipedia.org
			http://www.wikipedia.cz
**********************************************************/

/**********************************************************
********************* FILE-TRANSPORT **********************
**********************************************************/

#pragma comment( lib, "wsock32.lib")

#include <conio.h>
#include <stdio.h>
#include <string.h>
#include <winsock2.h>

/**********************************************************
------ Zavedeni symbolickych konstant ---------------------
***********************************************************/
typedef unsigned char U8;
//---------------------------------------------------------
#define DAT     0x00    // flag
#define SYN     0x01    // flag
#define FIN     0x02    // flag
#define RST     0x04    // flag
//---------------------------------------------------------
#define HEAD    9			// delka hlavicky
#define REPEAT  3			// pocet pokusu na spojeni
#define buflng  512			// delka pracovnich buferu
#define granularity 10		// rotec vzorkovani pri prijmu dat [ms]
#define window  8192		// okno datove historie
#define EMPTY   0xFFFFFFFF	// prazny slot
//---------------------------------------------------------
#define limiter "-------------------------------------------------------------------------------\n"

/**********************************************************
------ Deklarace funkci -----------------------------------
***********************************************************/
int WinsockIni();									// Inicializace Win socketu
int CreateSocket(SOCKET *sck);						// Vytvoreni socketu
int DeblockSocket(SOCKET *sck);						// Prepnuti socketu do neblokovaciho rezimu
int SendData(SOCKET *sck,char buf[], int cdat);		// Odeslani dat
int ReadData(SOCKET *sck,char buf[],int timeout);	// Prijem dat
void CopyPole(int ofsetz,char zdroj[],int ofsetc,char cil[],int pocet);	// Kopirovani bloku
void GetHEAD(char buf[],struct pct &h);				// Read HEAD
void SetHEAD(char buf[],struct pct &h);				// Set HEAD
void Echo(struct pct h,int n,char rtx[]);			// Print info


/**********************************************************
----- Zavedeni globalnich promennych ----------------------
**********************************************************/
sockaddr_in service;
//---------------------------------------------------------
char SOUBOR[65]="FILE_TRANSPORT.NUL";	// File name default test
char TPADR[16]="192.168.123.123";		// IP Default - local test
char PRT[16]="3556";					// PORT Default test

/**********************************************************
----- Deklarace PACKETU -----------------------------------
**********************************************************/
struct pct	//def packetu
       {
       unsigned long ID;	//id spojeni
       unsigned int  SEQ;	//sequencni cislo
       unsigned int  ACK;	//potvryovqci sekvence
       unsigned char FLG;	//signalizace spojeni 
       };
//---------------------------------------------------------
struct pct HTX,HRX;

/**********************************************************
----- Deklarace File -----------------------------------
**********************************************************/
FILE *file;

/**********************************************************
----- Inicializace Win socketu ----------------------------
**********************************************************/
int WinsockIni()  
{
    WSADATA wsaData;
    int iResult = WSAStartup(MAKEWORD(2,2), &wsaData);
    if (iResult != NO_ERROR)
    return -1;
    else
    return 0;
}

/**********************************************************
----- Vytvoreni socketu -----------------------------------
**********************************************************/
int CreateSocket(SOCKET *sck)
{

    *sck = socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP);
    if (*sck == INVALID_SOCKET)
        {        
        WSACleanup();
        return -1;
        }
        else
        {
        return 0;
        }
}

/**********************************************************
----- Prepnuti socketu do neblokovaciho rezimu ------------
**********************************************************/
int DeblockSocket(SOCKET *sck)
{
    u_long arg = 1;
    if (ioctlsocket(*sck, FIONBIO, &arg) == SOCKET_ERROR)
        {
        WSACleanup();
        return -1;
        }
        return 0;
}

/**********************************************************
----- Odeslani dat ----------------------------------------
**********************************************************/
int SendData(SOCKET *sck,char buf[], int cdat)
{
return sendto(*sck, buf, cdat, 0, (SOCKADDR *) &service, sizeof(service));
}

/**********************************************************
----- Prijem dat ------------------------------------------
**********************************************************/
int ReadData(SOCKET *sck,char buf[],int timeout)
{
int b=0;
int sersize = sizeof(service);


while((b<=0)&&(timeout>0))
{
b=recvfrom(*sck, buf, buflng, 0, (SOCKADDR *) &service, &sersize);
timeout=timeout-granularity;
Sleep(granularity);
}
return b;
}

/**********************************************************
----- Kopirovani bloku ------------------------------------
**********************************************************/
void CopyPole(int ofsetz,char zdroj[],int ofsetc,char cil[],int pocet)
{
for( ;pocet>0;pocet--) cil[ofsetc+pocet-1]=zdroj[ofsetz+pocet-1];
}

/**********************************************************
----- Read HEAD -------------------------------------------
**********************************************************/
void GetHEAD(char buf[],struct pct &h)
{
h.ID=((U8)buf[3]<<24)|((U8)buf[2]<<16)|((U8)buf[1]<<8)|((U8)buf[0]<<0);
//id=((U8)buf[0]<<24)|((U8)buf[1]<<16)|((U8)buf[2]<<8)|((U8)buf[3]<<0);

h.SEQ=((U8)buf[4]<<8)|((U8)buf[5]<<0);

h.ACK=((U8)buf[6]<<8)|((U8)buf[7]<<0);

h.FLG=(U8)buf[8];
}

/**********************************************************
----- Set HEAD --------------------------------------------
**********************************************************/
void SetHEAD(char buf[],struct pct &h)
{
buf[3]=(U8)((h.ID>>24)&0x000000FF);
buf[2]=(U8)((h.ID>>16)&0x000000FF);
buf[1]=(U8)((h.ID>>8)&0x000000FF);
buf[0]=(U8)((h.ID>>0)&0x000000FF);


buf[4]=(U8)((h.SEQ>>8)&0x00FF);
buf[5]=(U8)((h.SEQ>>0)&0x00FF);

buf[6]=(U8)((h.ACK>>8)&0x00FF);
buf[7]=(U8)((h.ACK>>0)&0x00FF);

buf[8]=h.FLG;

}

/**********************************************************
----- Print info ------------------------------------------
**********************************************************/
void Echo(struct pct h,int n,char rtx[])
{
printf("ID:%08X  %s   SEQ:%5d  ACK:%5d  FLG:%02X   DAT:%3d\n",h.ID,rtx,h.SEQ,h.ACK,h.FLG,n);
}

/**********************************************************
----- Main ------------------------------------------------
**********************************************************/
int main(int argc,char *args[])
{

printf(limiter);
printf(limiter);
printf(limiter);

//kontrola, zda jsou dodany vsechny 4 argumenty
if(argc<4)
    {
    printf("Spatny pocet parametru\n");
    printf("Zadej: IP PORT GETFILE SAVEFILE\n");
    while(!_kbhit()){};
    return -1;
    }

// parametry z prikazove radky do IP a PORT
strcpy(TPADR,args[1]);strcpy(PRT,args[2]);

// definovani promenne SOCKET   
SOCKET TRANS;

// inicializace SOCKETU 
if (WinsockIni() != 0) 
    {
    printf("Nepovedlo se zinicializovat WINSOCK\n");    
    printf(limiter);
    return -1;
    }

// vytvoreni SOCKETU
if (CreateSocket(&TRANS) != 0) 
    {
    printf("Chyba pri vytvareni socketu\n");
    printf(limiter);
    return -2;
    }

// aktivace neblokujiciho rezimu = neceka na prichozi data kdyz tam nejsou
if (DeblockSocket(&TRANS) !=0)
    {
    printf("Chyba pro prepnuti do neblokovaciho rezimu\n");
    printf(limiter);
    return -3;
    }

/**********************************************************
----- Inicializace na pocatecni stav ----------------------
**********************************************************/
char text[buflng];
char rcv[buflng];
char trs[buflng];
unsigned int n,m,o;

service.sin_family = AF_INET;
service.sin_addr.s_addr = inet_addr(TPADR);
service.sin_port = htons(atoi(PRT));

int sersize = sizeof(service);

//---------------------------------------------------------
//  Navazovani spojeni = osloveni serveru
//---------------------------------------------------------
m=REPEAT;

while(1)
    {
    HTX.ID=0;
    HTX.SEQ=1;
    HTX.ACK=0;
    HTX.FLG=SYN;		//nastaveny priznak pro server, odpovi cislem ID spojeni
    SetHEAD(trs,HTX);
    Echo(HTX,0,"SEND");    
    SendData(&TRANS,trs,HEAD);
    n=ReadData(&TRANS,rcv,2000);
    if(n==HEAD)
        {
        GetHEAD(rcv,HRX);   
        if((HRX.FLG == SYN)&&(HRX.SEQ !=0)) break;
        }
    if(m>0) m--;else return -1;
    }

Echo(HRX,n-HEAD,"RECV");

//---------------------------------------------------------
//  Zadost o soubor  = posle GET + jmeno souboru              
//---------------------------------------------------------
HTX.ID=HRX.ID;
HTX.FLG=DAT;
HTX.SEQ++;
HTX.ACK=HRX.SEQ+1;
m=REPEAT;
while(m>0)
    {
    SetHEAD(trs,HTX);
    sprintf(text,"GET%s",args[3]);o=strlen(text);CopyPole(0,text,HEAD,trs,HEAD+o);
    Echo(HTX,o,"SEND");    
    SendData(&TRANS,trs,HEAD+o);
    n=ReadData(&TRANS,rcv,2000);
    GetHEAD(rcv,HRX);Echo(HRX,n-HEAD,"RECV");
    if(HRX.ACK==HTX.SEQ+o) break;
    if(m>0) m--;else return -1;
    }

m=REPEAT;
while(m>0)
    {
    HTX.ID=HRX.ID;
    HTX.FLG=FIN;
    HTX.SEQ=HRX.ACK;
    HTX.ACK=HRX.SEQ+1;
    SetHEAD(trs,HTX);
    Echo(HTX,0,"SEND");    
    SendData(&TRANS,trs,HEAD);
    n=ReadData(&TRANS,rcv,3000);
    GetHEAD(rcv,HRX);
    Echo(HRX,n-HEAD,"RECV");
    if((HRX.ACK==HTX.SEQ+1)&&(HRX.SEQ==HTX.ACK-1)) break;
    if(m>0) m--;else return -1;
    }

printf(limiter);

/**********************************************************
----- Prijem souboru = OKNA -------------------------------
**********************************************************/
struct wnd
        {
        unsigned char cnt;      // pocet opakovanych prijeti (informacni udaj)
        unsigned long sta;      // start datove sequence
        unsigned long ndat;     // pocet dat
        unsigned char dat;      // data
        };

struct wnd okno[window];
unsigned int poz=0;
unsigned int winpoz=0;
unsigned int nextwinpoz=0;
unsigned int lastseq=HRX.SEQ;

//------------------------------------
// Otevreni log soubor pro ulozeni dat  
//------------------------------------ 
sprintf(SOUBOR,"%s",args[4]);
file = fopen(SOUBOR,"wb");

//----------------
// Vynulovani okna
//----------------
for(m=0;m<window-1;m++) 
    {
    okno[m].cnt=0x00;
    okno[m].sta= EMPTY;
    okno[m].ndat= EMPTY;
    okno[m].dat=0xFF;
    }

//-----------------------------------
// Cekani na paket nebo stisk klavesy
//-----------------------------------
while( (!_kbhit())&&(HRX.FLG !=RST) && (HRX.FLG !=FIN)   )
{

n=ReadData(&TRANS,rcv,3000);GetHEAD(rcv,HRX);

if (n>HEAD)  
    { 
        
    //--------------------------------------
    // Usazeni bloku na spravne misto v okne
    //--------------------------------------
    poz=((unsigned int)(HRX.SEQ-lastseq) & (window-1));
    okno[poz].cnt++;                // zapocita paket
    okno[poz].sta=HRX.SEQ;          // "praporek" = znacka zacatek
    okno[poz].ndat=n-HEAD;          // delka dat
    for(m=0;m<n-HEAD;m++) okno[poz+m].dat=rcv[HEAD+m];
    
	//-------------------------------
    // Zjisteni kontinuity mezi bloky
    //-------------------------------
    HTX.ACK=lastseq;
    winpoz=0;
    while(1)
        {
        if (okno[winpoz].sta != EMPTY) HTX.ACK = (unsigned int)(okno[winpoz].sta + okno[winpoz].ndat);

        nextwinpoz=winpoz+okno[winpoz].ndat;

        if(okno[nextwinpoz].sta == EMPTY) break;

        winpoz=nextwinpoz;
        
        }
    
    //--------------------------------------
    // Nastaveni casti hlavicky pro vysilani
    //--------------------------------------
    HTX.ID=HRX.ID;
    HTX.SEQ=HRX.ACK+1;
    HTX.FLG=DAT;
    SetHEAD(trs,HTX);

	//-------------------------------------
    // Posunuti okna a zapis dat do souboru
    //-------------------------------------
    if (winpoz>window/2)
        {
        winpoz=winpoz-okno[0].ndat+n-HEAD;        
        for (m=0;m<okno[0].ndat;m++) fprintf(file,"%c",okno[m].dat);
            
        lastseq=lastseq+okno[0].ndat;
        poz=okno[0].ndat;
        for(m=0;m<window-256;m++)
            {
            okno[m].cnt=okno[m+poz].cnt;
            okno[m].sta=okno[m+poz].sta;
            okno[m].ndat=okno[m+poz].ndat;
            okno[m].dat=okno[m+poz].dat;
            }
        }    
    }

if (n==HEAD) 
    { 
    HTX.ID=HRX.ID;
    HTX.FLG=RST;		//FIN nefungoval, z toho duvodu pouzit RESET
    HTX.SEQ=HTX.SEQ+1;
    HTX.ACK=HRX.SEQ;
    SetHEAD(trs,HTX);
    }

//-----------------
// Vypis na displej
//-----------------
Echo(HRX,n-HEAD,"RECV");
Echo(HTX,0,"SEND");

//-----------------
// Odeslani opovedi
//-----------------
SendData(&TRANS,trs,HEAD);

}

printf(limiter);
printf(limiter);
if(HRX.FLG==FIN) 
    {

    //------------------------------
    // Ulozeni zbytku dat do souboru
    //------------------------------
    for (m=0;m<winpoz;m++) fprintf(file,"%c",okno[m].dat);        
    printf("*******  SOUBOR  JE V POCITACI *******\n");
    }

if(HRX.FLG==RST) printf("!!!!!!!    CHYBA PRI PRENOSU   !!!!!!!\n");
printf(limiter);
printf(limiter);

closesocket(TRANS);

WSACleanup();

//----------------
// Zavreni souboru
//----------------
fclose(file);

//--------------------------------------------
// Stiskni libovolnou klavesu a ukonci program
//--------------------------------------------
while(!_kbhit()){};
return 0;
}